Index: c/src/exec/rtems/src/tasks.c
===================================================================
--- c/src/exec/rtems/src/tasks.c	(revision b3ac6a8dfe10aeaf3a9c59fd145bddfff119480e)
+++ c/src/exec/rtems/src/tasks.c	(revision 3652ad356bf13abe0963c992cbbda96476d31609)
@@ -115,24 +115,19 @@
  
   _ISR_Disable( level );
-
-  signal_set = asr->signals_posted;
- 
-  if ( signal_set ) {
-  /* if ( _ASR_Are_signals_pending( asr ) ) {
- 
-    signal_set          = asr->signals_posted; */
+    signal_set = asr->signals_posted;
     asr->signals_posted = 0;
-    _ISR_Enable( level );
- 
-    asr->nest_level += 1;
-    rtems_task_mode( asr->mode_set, RTEMS_ALL_MODE_MASKS, &prev_mode );
- 
-    (*asr->handler)( signal_set );
- 
-    asr->nest_level -= 1;
-    rtems_task_mode( prev_mode, RTEMS_ALL_MODE_MASKS, &prev_mode );
-  }
-  else
-    _ISR_Enable( level );
+  _ISR_Enable( level );
+ 
+ 
+  if ( !signal_set ) /* similar to _ASR_Are_signals_pending( asr ) */
+    return;
+ 
+  asr->nest_level += 1;
+  rtems_task_mode( asr->mode_set, RTEMS_ALL_MODE_MASKS, &prev_mode );
+ 
+  (*asr->handler)( signal_set );
+
+  asr->nest_level -= 1;
+  rtems_task_mode( prev_mode, RTEMS_ALL_MODE_MASKS, &prev_mode );
 
 }
Index: c/src/exec/sapi/headers/confdefs.h
===================================================================
--- c/src/exec/sapi/headers/confdefs.h	(revision b3ac6a8dfe10aeaf3a9c59fd145bddfff119480e)
+++ c/src/exec/sapi/headers/confdefs.h	(revision 3652ad356bf13abe0963c992cbbda96476d31609)
@@ -237,11 +237,106 @@
 #endif
 
-/* Calculate the RAM size based on the maximum number of tasks configured */
+/* 
+ *  Calculate the RAM size based on the maximum number of objects configured.
+ *  The model is to estimate the memory required for each configured item,
+ *  sum the memory requirements and insure that there is at least 32K greater 
+ *  than that for things not directly addressed such as:
+ *
+ *    + stacks greater than minimum size
+ *    + FP contexts
+ *    + API areas (should be optional)
+ *    + messages
+ *    + object name and local pointer table overhead
+ *    + per node memory requirements
+ *    + executive fixed requirements (including at least internal threads
+ *       and the Ready chains)
+ *
+ *  NOTE:  Eventually this should take into account some of the above.
+ *         Basically, this is a "back of the envelope" estimate for
+ *         memory requirements.  It could be more accurate.
+ */
 
 #ifndef CONFIGURE_EXECUTIVE_RAM_SIZE
-#define CONFIGURE_MEMORY_REQUIRED(_tasks) \
-  (_tasks) * ( (sizeof(Thread_Control) + CONTEXT_FP_SIZE + STACK_MINIMUM_SIZE)) 
+
+#define CONFIGURE_OBJECT_TABLE_STUFF \
+  ( sizeof(Objects_Control *) + sizeof(rtems_name *) + sizeof(rtems_name) )
+
+#define CONFIGURE_MEMORY_FOR_TASKS(_tasks) \
+  ((_tasks) * \
+   ((sizeof(Thread_Control) + CONTEXT_FP_SIZE + \
+      STACK_MINIMUM_SIZE + sizeof( RTEMS_API_Control ) + \
+      CONFIGURE_OBJECT_TABLE_STUFF)) \
+  )
+
+#define CONFIGURE_MEMORY_FOR_TIMERS(_timers) \
+  ((_timers) * ( sizeof(Timer_Control) + CONFIGURE_OBJECT_TABLE_STUFF ) )
+
+#define CONFIGURE_MEMORY_FOR_SEMAPHORES(_semaphores) \
+  ((_semaphores) * \
+   ( sizeof(Semaphore_Control) + CONFIGURE_OBJECT_TABLE_STUFF ) )
+
+#define CONFIGURE_MEMORY_FOR_MESSAGE_QUEUES(_queues) \
+  ( (_queues) * \
+    ( sizeof(Message_queue_Control) + CONFIGURE_OBJECT_TABLE_STUFF ) )
+
+#define CONFIGURE_MEMORY_FOR_PARTITIONS(_partitions) \
+  ( (_partitions) * \
+    ( sizeof(Partition_Control) + CONFIGURE_OBJECT_TABLE_STUFF ) )
+
+#define CONFIGURE_MEMORY_FOR_REGIONS(_regions) \
+  ( (_regions) * \
+    ( sizeof(Region_Control) + CONFIGURE_OBJECT_TABLE_STUFF ) )
+
+#define CONFIGURE_MEMORY_FOR_PORTS(_ports) \
+  ( (_ports) * \
+    ( sizeof(Dual_ported_memory_Control) + CONFIGURE_OBJECT_TABLE_STUFF ) )
+
+#define CONFIGURE_MEMORY_FOR_PERIODS(_periods) \
+  ( (_periods) * \
+    ( sizeof(Rate_monotonic_Control) + CONFIGURE_OBJECT_TABLE_STUFF ) )
+
+#define CONFIGURE_MEMORY_FOR_USER_EXTENSIONS(_extensions) \
+  ( (_extensions) * \
+    ( sizeof(Extension_Control) + CONFIGURE_OBJECT_TABLE_STUFF ) )
+
+#define CONFIGURE_MEMORY_FOR_DEVICES(_devices) \
+  (((_devices) + 1) * ( sizeof(rtems_driver_name_t) ) )
+
+#ifdef CONFIGURE_MPTEST
+
+#ifndef CONFIGURE_HAS_OWN_MULTIPROCESING_TABLE
+
+#define CONFIGURE_MEMORY_FOR_PROXIES(_proxies) \
+  ( ((_proxies) + 1) * ( sizeof(Thread_Proxy_control) )  )
+
+#define CONFIGURE_MEMORY_FOR_GLOBAL_OBJECTS(_global_objects) \
+  ((_global_objects)  * ( sizeof(Objects_MP_Control) )  )
+
+#define CONFIGURE_MEMORY_FOR_MP \
+  ( CONFIGURE_MEMORY_FOR_PROXIES(CONFIGURE_MP_MAXIMUM_PROXIES) + \
+    CONFIGURE_MEMORY_FOR_GLOBAL_OBJECTS(CONFIGURE_MP_MAXIMUM_GLOBAL_OBJECTS) \
+  )
+
+#endif  /* CONFIGURE_HAS_OWN_MULTIPROCESING_TABLE */
+
+#else
+
+#define CONFIGURE_MEMORY_FOR_MP  0
+
+#endif
 #define CONFIGURE_EXECUTIVE_RAM_SIZE \
-( (CONFIGURE_MEMORY_REQUIRED(CONFIGURE_MAXIMUM_TASKS) + (128*1024)) &0xffff0000)
+(( CONFIGURE_MEMORY_FOR_TASKS(CONFIGURE_MAXIMUM_TASKS) + \
+   CONFIGURE_MEMORY_FOR_TIMERS(CONFIGURE_MAXIMUM_TIMERS) + \
+   CONFIGURE_MEMORY_FOR_SEMAPHORES(CONFIGURE_MAXIMUM_SEMAPHORES) + \
+   CONFIGURE_MEMORY_FOR_MESSAGE_QUEUES(CONFIGURE_MAXIMUM_MESSAGE_QUEUES) + \
+   CONFIGURE_MEMORY_FOR_PARTITIONS(CONFIGURE_MAXIMUM_PARTITIONS) + \
+   CONFIGURE_MEMORY_FOR_REGIONS(CONFIGURE_MAXIMUM_REGIONS) + \
+   CONFIGURE_MEMORY_FOR_PORTS(CONFIGURE_MAXIMUM_PORTS) + \
+   CONFIGURE_MEMORY_FOR_PERIODS(CONFIGURE_MAXIMUM_PERIODS) + \
+   CONFIGURE_MEMORY_FOR_USER_EXTENSIONS(CONFIGURE_MAXIMUM_USER_EXTENSIONS) + \
+   CONFIGURE_MEMORY_FOR_DEVICES(CONFIGURE_MAXIMUM_DEVICES) + \
+   CONFIGURE_MEMORY_FOR_MP + \
+   (96*1024) \
+) & 0xffff8000)
 #endif
 
Index: c/src/exec/sapi/include/confdefs.h
===================================================================
--- c/src/exec/sapi/include/confdefs.h	(revision b3ac6a8dfe10aeaf3a9c59fd145bddfff119480e)
+++ c/src/exec/sapi/include/confdefs.h	(revision 3652ad356bf13abe0963c992cbbda96476d31609)
@@ -237,11 +237,106 @@
 #endif
 
-/* Calculate the RAM size based on the maximum number of tasks configured */
+/* 
+ *  Calculate the RAM size based on the maximum number of objects configured.
+ *  The model is to estimate the memory required for each configured item,
+ *  sum the memory requirements and insure that there is at least 32K greater 
+ *  than that for things not directly addressed such as:
+ *
+ *    + stacks greater than minimum size
+ *    + FP contexts
+ *    + API areas (should be optional)
+ *    + messages
+ *    + object name and local pointer table overhead
+ *    + per node memory requirements
+ *    + executive fixed requirements (including at least internal threads
+ *       and the Ready chains)
+ *
+ *  NOTE:  Eventually this should take into account some of the above.
+ *         Basically, this is a "back of the envelope" estimate for
+ *         memory requirements.  It could be more accurate.
+ */
 
 #ifndef CONFIGURE_EXECUTIVE_RAM_SIZE
-#define CONFIGURE_MEMORY_REQUIRED(_tasks) \
-  (_tasks) * ( (sizeof(Thread_Control) + CONTEXT_FP_SIZE + STACK_MINIMUM_SIZE)) 
+
+#define CONFIGURE_OBJECT_TABLE_STUFF \
+  ( sizeof(Objects_Control *) + sizeof(rtems_name *) + sizeof(rtems_name) )
+
+#define CONFIGURE_MEMORY_FOR_TASKS(_tasks) \
+  ((_tasks) * \
+   ((sizeof(Thread_Control) + CONTEXT_FP_SIZE + \
+      STACK_MINIMUM_SIZE + sizeof( RTEMS_API_Control ) + \
+      CONFIGURE_OBJECT_TABLE_STUFF)) \
+  )
+
+#define CONFIGURE_MEMORY_FOR_TIMERS(_timers) \
+  ((_timers) * ( sizeof(Timer_Control) + CONFIGURE_OBJECT_TABLE_STUFF ) )
+
+#define CONFIGURE_MEMORY_FOR_SEMAPHORES(_semaphores) \
+  ((_semaphores) * \
+   ( sizeof(Semaphore_Control) + CONFIGURE_OBJECT_TABLE_STUFF ) )
+
+#define CONFIGURE_MEMORY_FOR_MESSAGE_QUEUES(_queues) \
+  ( (_queues) * \
+    ( sizeof(Message_queue_Control) + CONFIGURE_OBJECT_TABLE_STUFF ) )
+
+#define CONFIGURE_MEMORY_FOR_PARTITIONS(_partitions) \
+  ( (_partitions) * \
+    ( sizeof(Partition_Control) + CONFIGURE_OBJECT_TABLE_STUFF ) )
+
+#define CONFIGURE_MEMORY_FOR_REGIONS(_regions) \
+  ( (_regions) * \
+    ( sizeof(Region_Control) + CONFIGURE_OBJECT_TABLE_STUFF ) )
+
+#define CONFIGURE_MEMORY_FOR_PORTS(_ports) \
+  ( (_ports) * \
+    ( sizeof(Dual_ported_memory_Control) + CONFIGURE_OBJECT_TABLE_STUFF ) )
+
+#define CONFIGURE_MEMORY_FOR_PERIODS(_periods) \
+  ( (_periods) * \
+    ( sizeof(Rate_monotonic_Control) + CONFIGURE_OBJECT_TABLE_STUFF ) )
+
+#define CONFIGURE_MEMORY_FOR_USER_EXTENSIONS(_extensions) \
+  ( (_extensions) * \
+    ( sizeof(Extension_Control) + CONFIGURE_OBJECT_TABLE_STUFF ) )
+
+#define CONFIGURE_MEMORY_FOR_DEVICES(_devices) \
+  (((_devices) + 1) * ( sizeof(rtems_driver_name_t) ) )
+
+#ifdef CONFIGURE_MPTEST
+
+#ifndef CONFIGURE_HAS_OWN_MULTIPROCESING_TABLE
+
+#define CONFIGURE_MEMORY_FOR_PROXIES(_proxies) \
+  ( ((_proxies) + 1) * ( sizeof(Thread_Proxy_control) )  )
+
+#define CONFIGURE_MEMORY_FOR_GLOBAL_OBJECTS(_global_objects) \
+  ((_global_objects)  * ( sizeof(Objects_MP_Control) )  )
+
+#define CONFIGURE_MEMORY_FOR_MP \
+  ( CONFIGURE_MEMORY_FOR_PROXIES(CONFIGURE_MP_MAXIMUM_PROXIES) + \
+    CONFIGURE_MEMORY_FOR_GLOBAL_OBJECTS(CONFIGURE_MP_MAXIMUM_GLOBAL_OBJECTS) \
+  )
+
+#endif  /* CONFIGURE_HAS_OWN_MULTIPROCESING_TABLE */
+
+#else
+
+#define CONFIGURE_MEMORY_FOR_MP  0
+
+#endif
 #define CONFIGURE_EXECUTIVE_RAM_SIZE \
-( (CONFIGURE_MEMORY_REQUIRED(CONFIGURE_MAXIMUM_TASKS) + (128*1024)) &0xffff0000)
+(( CONFIGURE_MEMORY_FOR_TASKS(CONFIGURE_MAXIMUM_TASKS) + \
+   CONFIGURE_MEMORY_FOR_TIMERS(CONFIGURE_MAXIMUM_TIMERS) + \
+   CONFIGURE_MEMORY_FOR_SEMAPHORES(CONFIGURE_MAXIMUM_SEMAPHORES) + \
+   CONFIGURE_MEMORY_FOR_MESSAGE_QUEUES(CONFIGURE_MAXIMUM_MESSAGE_QUEUES) + \
+   CONFIGURE_MEMORY_FOR_PARTITIONS(CONFIGURE_MAXIMUM_PARTITIONS) + \
+   CONFIGURE_MEMORY_FOR_REGIONS(CONFIGURE_MAXIMUM_REGIONS) + \
+   CONFIGURE_MEMORY_FOR_PORTS(CONFIGURE_MAXIMUM_PORTS) + \
+   CONFIGURE_MEMORY_FOR_PERIODS(CONFIGURE_MAXIMUM_PERIODS) + \
+   CONFIGURE_MEMORY_FOR_USER_EXTENSIONS(CONFIGURE_MAXIMUM_USER_EXTENSIONS) + \
+   CONFIGURE_MEMORY_FOR_DEVICES(CONFIGURE_MAXIMUM_DEVICES) + \
+   CONFIGURE_MEMORY_FOR_MP + \
+   (96*1024) \
+) & 0xffff8000)
 #endif
 
Index: c/src/exec/score/cpu/hppa1.1/cpu.c
===================================================================
--- c/src/exec/score/cpu/hppa1.1/cpu.c	(revision b3ac6a8dfe10aeaf3a9c59fd145bddfff119480e)
+++ c/src/exec/score/cpu/hppa1.1/cpu.c	(revision 3652ad356bf13abe0963c992cbbda96476d31609)
@@ -194,5 +194,5 @@
 hppa_external_interrupt_initialize(void)
 {
-    hppa_rtems_isr_entry ignore;
+    hppa_rtems_isr_entry ignore = 0;
 
     /* mark them all unused */
@@ -202,6 +202,9 @@
 
     /* install the external interrupt handler */
-    rtems_interrupt_catch((rtems_isr_entry) hppa_external_interrupt,
-                          HPPA_INTERRUPT_EXTERNAL_INTERRUPT, &ignore) ;
+  _CPU_ISR_install_vector(
+    HPPA_INTERRUPT_EXTERNAL_INTERRUPT,
+    (proc_ptr)hppa_external_interrupt,
+    (proc_ptr *)ignore
+  );
 }
 
Index: c/src/exec/score/cpu/hppa1.1/cpu_asm.s
===================================================================
--- c/src/exec/score/cpu/hppa1.1/cpu_asm.s	(revision b3ac6a8dfe10aeaf3a9c59fd145bddfff119480e)
+++ c/src/exec/score/cpu/hppa1.1/cpu_asm.s	(revision 3652ad356bf13abe0963c992cbbda96476d31609)
@@ -25,5 +25,5 @@
 #      suitability of this software for any purpose.
 #
- *  $Id$
+#  $Id$
 #
 
Index: c/src/exec/score/cpu/hppa1.1/hppa.h
===================================================================
--- c/src/exec/score/cpu/hppa1.1/hppa.h	(revision b3ac6a8dfe10aeaf3a9c59fd145bddfff119480e)
+++ c/src/exec/score/cpu/hppa1.1/hppa.h	(revision 3652ad356bf13abe0963c992cbbda96476d31609)
@@ -637,5 +637,5 @@
 
 #define EMIT_SET_CONTROL(name, reg)            \
-static __inline__ unsigned int                 \
+static __inline__ void                         \
 set_ ## name (unsigned int new_value)          \
 {                                              \
Index: c/src/exec/score/cpu/hppa1.1/rtems.s
===================================================================
--- c/src/exec/score/cpu/hppa1.1/rtems.s	(revision b3ac6a8dfe10aeaf3a9c59fd145bddfff119480e)
+++ c/src/exec/score/cpu/hppa1.1/rtems.s	(revision 3652ad356bf13abe0963c992cbbda96476d31609)
@@ -15,5 +15,5 @@
  */
 
-#include <rtems/hppa.h>
+#include <rtems/core/hppa.h>
 #include <rtems/core/cpu_asm.h>
 
Index: c/src/exec/score/cpu/i386/cpu.c
===================================================================
--- c/src/exec/score/cpu/i386/cpu.c	(revision b3ac6a8dfe10aeaf3a9c59fd145bddfff119480e)
+++ c/src/exec/score/cpu/i386/cpu.c	(revision 3652ad356bf13abe0963c992cbbda96476d31609)
@@ -35,5 +35,5 @@
 {
   register unsigned16  fp_status asm ("ax");
-  register unsigned8  *fp_context;
+  register void       *fp_context;
 
   _CPU_Table = *cpu_table;
@@ -57,5 +57,5 @@
   if ( fp_status ==  0 ) {
 
-    fp_context = _CPU_Null_fp_context;
+    fp_context = &_CPU_Null_fp_context;
 
     asm volatile( "fsave (%0)" : "=r" (fp_context)
Index: c/src/exec/score/cpu/i386/cpu.h
===================================================================
--- c/src/exec/score/cpu/i386/cpu.h	(revision b3ac6a8dfe10aeaf3a9c59fd145bddfff119480e)
+++ c/src/exec/score/cpu/i386/cpu.h	(revision 3652ad356bf13abe0963c992cbbda96476d31609)
@@ -148,9 +148,7 @@
 /*
  *  Minimum size of a thread's stack.
- *
- *  NOTE:  256 bytes is probably too low in most cases.
- */
-
-#define CPU_STACK_MINIMUM_SIZE          256
+ */
+
+#define CPU_STACK_MINIMUM_SIZE          1024
 
 /*
@@ -233,6 +231,6 @@
 #define _CPU_Context_Initialize_fp( _fp_area ) \
   { \
-    unsigned32 *_source      = (unsigned32 *) _CPU_Null_fp_context; \
-    unsigned32 *_destination = (unsigned32 *) *(_fp_area); \
+    unsigned32 *_source      = (unsigned32 *) &_CPU_Null_fp_context; \
+    unsigned32 *_destination = *(_fp_area); \
     unsigned32  _index; \
     \
Index: c/src/exec/score/cpu/i386/i386.h
===================================================================
--- c/src/exec/score/cpu/i386/i386.h	(revision b3ac6a8dfe10aeaf3a9c59fd145bddfff119480e)
+++ c/src/exec/score/cpu/i386/i386.h	(revision 3652ad356bf13abe0963c992cbbda96476d31609)
@@ -171,6 +171,6 @@
     register unsigned32 _eflags = 0; \
     \
-    asm volatile ( "push %0 ; \
-                    popf " \
+    asm volatile ( "pushf ; \
+                    pop %0" \
                     : "=r" ((_eflags)) : "0" ((_eflags)) \
     ); \
Index: c/src/exec/score/cpu/i960/cpu.h
===================================================================
--- c/src/exec/score/cpu/i960/cpu.h	(revision b3ac6a8dfe10aeaf3a9c59fd145bddfff119480e)
+++ c/src/exec/score/cpu/i960/cpu.h	(revision 3652ad356bf13abe0963c992cbbda96476d31609)
@@ -180,5 +180,5 @@
 
 #define CPU_SYSTEM_INITIALIZATION_THREAD_EXTRA_STACK \
-   (4096 - CPU_STACK_MINIMUM_SIZE)
+   (CPU_STACK_MINIMUM_SIZE)
 
 /*
@@ -194,5 +194,5 @@
  */
 
-#define CPU_STACK_MINIMUM_SIZE          1024
+#define CPU_STACK_MINIMUM_SIZE          2048
 
 /*
Index: c/src/exec/score/cpu/m68k/cpu.h
===================================================================
--- c/src/exec/score/cpu/m68k/cpu.h	(revision b3ac6a8dfe10aeaf3a9c59fd145bddfff119480e)
+++ c/src/exec/score/cpu/m68k/cpu.h	(revision 3652ad356bf13abe0963c992cbbda96476d31609)
@@ -178,9 +178,7 @@
 /*
  *  Minimum size of a thread's stack.
- *
- *  NOTE:  256 bytes is probably too low in most cases.
- */
-
-#define CPU_STACK_MINIMUM_SIZE           256
+ */
+
+#define CPU_STACK_MINIMUM_SIZE           1024
 
 /*
Index: c/src/exec/score/cpu/unix/cpu.c
===================================================================
--- c/src/exec/score/cpu/unix/cpu.c	(revision b3ac6a8dfe10aeaf3a9c59fd145bddfff119480e)
+++ c/src/exec/score/cpu/unix/cpu.c	(revision 3652ad356bf13abe0963c992cbbda96476d31609)
@@ -1,4 +1,4 @@
 /*
- *  HP PA-RISC CPU Dependent Source
+ *  UNIX Simulator Dependent Source
  *
  *
@@ -19,4 +19,5 @@
 #include <rtems/system.h>
 #include <rtems/core/isr.h>
+#include <rtems/core/interr.h>
 
 #include <stdio.h>
@@ -170,19 +171,14 @@
 
   _CPU_ISR_Set_level( 0 );
-  setjmp( _CPU_Context_Default_with_ISRs_enabled.regs );
-  sigprocmask(
-    SIG_SETMASK,    /* ignored when second arg is NULL */
-    0,
-    &_CPU_Context_Default_with_ISRs_enabled.isr_level
+  _CPU_Context_switch(
+    &_CPU_Context_Default_with_ISRs_enabled,
+    &_CPU_Context_Default_with_ISRs_enabled
   );
 
   _CPU_ISR_Set_level( 1 );
-  setjmp( _CPU_Context_Default_with_ISRs_disabled.regs );
-  sigprocmask(
-    SIG_SETMASK,    /* ignored when second arg is NULL */
-    0,
-    &_CPU_Context_Default_with_ISRs_disabled.isr_level
+  _CPU_Context_switch(
+    &_CPU_Context_Default_with_ISRs_disabled,
+    &_CPU_Context_Default_with_ISRs_disabled
   );
-
 }
 
@@ -192,19 +188,19 @@
  */
 
+sigset_t GET_old_mask;
+
 unsigned32 _CPU_ISR_Get_level( void )
 {
-  sigset_t sigset;
- 
-  sigprocmask( 0, 0, &sigset ); 
-
-  /*
-   *  This is an educated guess based on ONLY ONE of the signals we
-   *  disable/enable to mask ISRs.
-   */
-
-  if ( sigismember( &sigset, SIGUSR1 ) )
-    return 1;
-  else
-    return 0;
+/*  sigset_t  old_mask; */
+   unsigned32 old_level;
+ 
+  sigprocmask(0, 0, &GET_old_mask);
+ 
+  if (memcmp((void *)&posix_empty_mask, (void *)&GET_old_mask, sizeof(sigset_t)))
+    old_level = 1;
+  else 
+    old_level = 0;
+
+  return old_level;
 }
 
@@ -384,5 +380,5 @@
     source = _CPU_Context_Default_with_ISRs_disabled.regs;
       
-  memcpy(_the_context, source, sizeof(jmp_buf));
+  memcpy(_the_context, source, sizeof(Context_Control) ); /* sizeof(jmp_buf)); */
 
   addr = (unsigned32 *)_the_context;
@@ -471,13 +467,28 @@
 )
 {
+  int status;
+
   /*
    *  Switch levels in one operation
    */
 
-  sigprocmask( SIG_SETMASK, &next->isr_level, &current->isr_level );
+  status = sigprocmask( SIG_SETMASK, &next->isr_level, &current->isr_level );
+  if ( status )
+    _Internal_error_Occurred(
+      INTERNAL_ERROR_CORE,
+      TRUE,
+      status
+    );
 
   if (setjmp(current->regs) == 0) {    /* Save the current context */
      longjmp(next->regs, 0);           /* Switch to the new context */
-  }
+     if ( status )
+       _Internal_error_Occurred(
+         INTERNAL_ERROR_CORE,
+         TRUE,
+         status
+       );
+  }
+
 }
  
@@ -511,9 +522,16 @@
 unsigned32 _CPU_ISR_Disable_support(void)
 {
+  int status;
   sigset_t  old_mask;
 
-  sigprocmask(SIG_BLOCK, &_CPU_Signal_mask, &old_mask);
-
-  if (memcmp((void *)&posix_empty_mask, (void *)&old_mask, sizeof(sigset_t)) != 0)
+  status = sigprocmask(SIG_BLOCK, &_CPU_Signal_mask, &old_mask);
+  if ( status )
+    _Internal_error_Occurred(
+      INTERNAL_ERROR_CORE,
+      TRUE,
+      status
+    );
+
+  if (memcmp((void *)&posix_empty_mask, (void *)&old_mask, sizeof(sigset_t)))
     return 1;
 
@@ -530,8 +548,17 @@
 )
 {
+  int status;
+
   if (level == 0)
-    sigprocmask(SIG_UNBLOCK, &_CPU_Signal_mask, 0);
+    status = sigprocmask(SIG_UNBLOCK, &_CPU_Signal_mask, 0);
   else
-    sigprocmask(SIG_BLOCK, &_CPU_Signal_mask, 0);
+    status = sigprocmask(SIG_BLOCK, &_CPU_Signal_mask, 0);
+
+  if ( status )
+    _Internal_error_Occurred(
+      INTERNAL_ERROR_CORE,
+      TRUE,
+      status
+    );
 }
 
Index: c/src/exec/score/headers/coremsg.h
===================================================================
--- c/src/exec/score/headers/coremsg.h	(revision 3652ad356bf13abe0963c992cbbda96476d31609)
+++ c/src/exec/score/headers/coremsg.h	(revision 3652ad356bf13abe0963c992cbbda96476d31609)
@@ -0,0 +1,408 @@
+/*  coremsg.h
+ *
+ *  This include file contains all the constants and structures associated
+ *  with the Message queue Handler.
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+ 
+#ifndef __RTEMS_CORE_MESSAGE_QUEUE_h
+#define __RTEMS_CORE_MESSAGE_QUEUE_h
+ 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <rtems/core/thread.h>
+#include <rtems/core/threadq.h>
+#include <rtems/core/priority.h>
+#include <rtems/core/watchdog.h>
+ 
+/*
+ *  The following type defines the callout which the API provides
+ *  to support global/multiprocessor operations on message_queues.
+ */
+ 
+typedef void ( *CORE_message_queue_API_mp_support_callout )(
+                 Thread_Control *,
+                 Objects_Id
+             );
+
+/*
+ *  The following defines the data types needed to manipulate
+ *  the contents of message buffers.
+ *  Since msgs are variable length we just make a ptr to 1.
+ */
+ 
+typedef struct {
+    unsigned32  size;
+ 
+#ifndef __cplusplus
+                               /* NOTE:   [0] is gcc specific,
+                                *   but specifically disallowed by ANSI STD C++
+                                * g++ warns about it, so we #ifdef it out to
+                                * get rid of warnings when compiled by g++.
+                                */
+    unsigned32  buffer[0];
+#endif
+ 
+} CORE_message_queue_Buffer;
+ 
+/*
+ *  The following records define the organization of a message
+ *  buffer.
+ */
+ 
+typedef struct {
+  Chain_Node                 Node;
+  CORE_message_queue_Buffer  Contents;
+}   CORE_message_queue_Buffer_control;
+
+/*
+ *  Blocking disciplines for a message_queue.
+ */
+
+typedef enum {
+  CORE_MESSAGE_QUEUE_DISCIPLINES_FIFO,
+  CORE_MESSAGE_QUEUE_DISCIPLINES_PRIORITY
+}   CORE_message_queue_Disciplines;
+
+/*
+ *  The following enumerated type details the modes in which a message
+ *  may be submitted to a message queue.  The message may be posted
+ *  in a send or urgent fashion.
+ */
+ 
+typedef enum {
+  CORE_MESSAGE_QUEUE_SEND_REQUEST   = 0,
+  CORE_MESSAGE_QUEUE_URGENT_REQUEST = 1
+}  CORE_message_queue_Submit_types;
+
+/*
+ *  Core Message queue handler return statuses.
+ */
+ 
+typedef enum {
+  CORE_MESSAGE_QUEUE_STATUS_SUCCESSFUL,
+  CORE_MESSAGE_QUEUE_STATUS_INVALID_SIZE,
+  CORE_MESSAGE_QUEUE_STATUS_TOO_MANY,
+  CORE_MESSAGE_QUEUE_STATUS_UNSATISFIED,
+  CORE_MESSAGE_QUEUE_STATUS_UNSATISFIED_NOWAIT,
+  CORE_MESSAGE_QUEUE_STATUS_WAS_DELETED,
+  CORE_MESSAGE_QUEUE_STATUS_TIMEOUT
+}   CORE_message_queue_Status;
+
+/*
+ *  The following defines the control block used to manage the 
+ *  attributes of each message queue.
+ */
+
+typedef struct {
+  CORE_message_queue_Disciplines  discipline;
+}   CORE_message_queue_Attributes;
+ 
+/*
+ *  The following defines the control block used to manage each 
+ *  counting message_queue.
+ */
+ 
+typedef struct {
+  Thread_queue_Control           Wait_queue;
+  CORE_message_queue_Attributes  Attributes;
+  unsigned32                     maximum_pending_messages;
+  unsigned32                     number_of_pending_messages;
+  unsigned32                     maximum_message_size;
+  Chain_Control                  Pending_messages;
+  CORE_message_queue_Buffer     *message_buffers;
+  Chain_Control                  Inactive_messages;
+}   CORE_message_queue_Control;
+
+/*
+ *  _CORE_message_queue_Initialize
+ *
+ *  DESCRIPTION:
+ *
+ *  This routine initializes the message_queue based on the parameters passed.
+ */
+
+boolean _CORE_message_queue_Initialize(
+  CORE_message_queue_Control    *the_message_queue,
+  Objects_Classes                the_class,
+  CORE_message_queue_Attributes *the_message_queue_attributes,
+  unsigned32                     maximum_pending_messages,
+  unsigned32                     maximum_message_size,
+  Thread_queue_Extract_callout   proxy_extract_callout
+);
+ 
+/*
+ *  _CORE_message_queue_Close
+ *
+ *  DESCRIPTION:
+ *
+ *  This function closes a message by returning all allocated space and
+ *  flushing the message_queue's task wait queue.
+ */
+ 
+void _CORE_message_queue_Close(
+  CORE_message_queue_Control *the_message_queue,
+  Thread_queue_Flush_callout  remote_extract_callout,
+  unsigned32                  status
+);
+
+/*
+ *
+ *  _CORE_message_queue_Flush
+ *
+ *  DESCRIPTION:
+ *
+ *  This function flushes the message_queue's task wait queue.  The number
+ *  messages flushed from the queue is returned.
+ *
+ */
+
+unsigned32 _CORE_message_queue_Flush(
+  CORE_message_queue_Control *the_message_queue
+);
+
+/*
+ *  _CORE_message_queue_Flush_support
+ *
+ *  DESCRIPTION:
+ *
+ *  This routine flushes all outstanding messages and returns
+ *  them to the inactive message chain.
+ */
+ 
+unsigned32 _CORE_message_queue_Flush_support(
+  CORE_message_queue_Control *the_message_queue
+);
+ 
+/*
+ *  _CORE_message_queue_send
+ *
+ *  DESCRIPTION:
+ *
+ *  This routine sends a message to the end of the specified message queue.
+ *
+ */
+ 
+STATIC INLINE CORE_message_queue_Status _CORE_message_queue_Send(
+  CORE_message_queue_Control                *the_message_queue,
+  void                                      *buffer,
+  unsigned32                                 size,
+  Objects_Id                                 id,
+  CORE_message_queue_API_mp_support_callout  api_message_queue_mp_support
+);
+ 
+/*
+ *
+ *  _CORE_message_queue_Urgent
+ *
+ *  DESCRIPTION:
+ *
+ *  This routine sends a message to the front of the specified message queue.
+ *
+ */
+ 
+STATIC INLINE CORE_message_queue_Status _CORE_message_queue_Urgent(
+  CORE_message_queue_Control                *the_message_queue,
+  void                                      *buffer,
+  unsigned32                                 size,
+  Objects_Id                                 id,
+  CORE_message_queue_API_mp_support_callout  api_message_queue_mp_support
+);
+
+/*
+ *
+ *  _CORE_message_queue_Broadcast
+ *
+ *  DESCRIPTION:
+ *
+ *  This function sends a message for every thread waiting on the queue and
+ *  returns the number of threads made ready by the message.
+ *
+ */
+ 
+CORE_message_queue_Status _CORE_message_queue_Broadcast(
+  CORE_message_queue_Control                *the_message_queue,
+  void                                      *buffer,
+  unsigned32                                 size,
+  Objects_Id                                 id,
+  CORE_message_queue_API_mp_support_callout  api_message_queue_mp_support,
+  unsigned32                                *count
+);
+
+/*
+ *
+ *  _CORE_message_queue_Submit
+ *
+ *  DESCRIPTION:
+ *
+ *  This routine implements the send and urgent message functions. It
+ *  processes a message that is to be submitted to the designated
+ *  message queue.  The message will either be processed as a
+ *  send message which it will be inserted at the rear of the queue
+ *  or it will be processed as an urgent message which will be inserted
+ *  at the front of the queue.
+ *
+ */
+ 
+CORE_message_queue_Status _CORE_message_queue_Submit(
+  CORE_message_queue_Control                *the_message_queue,
+  void                                      *buffer,
+  unsigned32                                 size,
+  Objects_Id                                 id,
+  CORE_message_queue_API_mp_support_callout  api_message_queue_mp_support,
+  CORE_message_queue_Submit_types            submit_type
+);
+
+/*
+ *
+ *  _CORE_message_queue_Seize
+ *
+ *  DESCRIPTION:
+ *
+ *  This kernel routine dequeues a message, copies the message buffer to
+ *  a given destination buffer, and frees the message buffer to the
+ *  inactive message pool.  The thread will be blocked if wait is TRUE,
+ *  otherwise an error will be given to the thread if no messages are available.
+ *
+ */
+ 
+void _CORE_message_queue_Seize(
+  CORE_message_queue_Control *the_message_queue,
+  Objects_Id                  id,
+  void                       *buffer,
+  unsigned32                 *size,
+  boolean                     wait,
+  Watchdog_Interval           timeout
+);
+
+/*
+ *  _CORE_message_queue_Allocate_message_buffer
+ *
+ *  DESCRIPTION:
+ *
+ *  This function allocates a message buffer from the inactive
+ *  message buffer chain.
+ */
+ 
+STATIC INLINE CORE_message_queue_Buffer_control *
+  _CORE_message_queue_Allocate_message_buffer (
+   CORE_message_queue_Control *the_message_queue
+);
+
+/*
+ *  _CORE_message_queue_Free_message_buffer
+ *
+ *  DESCRIPTION:
+ *
+ *  This routine frees a message buffer to the inactive
+ *  message buffer chain.
+ */
+ 
+STATIC INLINE void _CORE_message_queue_Free_message_buffer (
+  CORE_message_queue_Control        *the_message_queue,
+  CORE_message_queue_Buffer_control *the_message
+);
+
+/*
+ *  _CORE_message_queue_Copy_buffer
+ *
+ *  DESCRIPTION:
+ *
+ *  This routine copies the contents of the source message buffer
+ *  to the destination message buffer.
+ */
+ 
+STATIC INLINE void _CORE_message_queue_Copy_buffer (
+  void      *source,
+  void      *destination,
+  unsigned32 size
+);
+
+/*
+ *  _CORE_message_queue_Get_pending_message
+ *
+ *  DESCRIPTION:
+ *
+ *  This function removes the first message from the_message_queue
+ *  and returns a pointer to it.
+ */
+ 
+STATIC INLINE
+  CORE_message_queue_Buffer_control *_CORE_message_queue_Get_pending_message (
+       CORE_message_queue_Control *the_message_queue
+);
+ 
+/*
+ *  _CORE_message_queue_Is_priority
+ *
+ *  DESCRIPTION:
+ *
+ *  This function returns TRUE if the priority attribute is
+ *  enabled in the attribute_set and FALSE otherwise.
+ */
+
+STATIC INLINE boolean _CORE_message_queue_Is_priority(
+  CORE_message_queue_Attributes *the_attribute
+);
+
+/*
+ *  _CORE_message_queue_Append
+ *
+ *  DESCRIPTION:
+ *
+ *  This routine places the_message at the rear of the outstanding
+ *  messages on the_message_queue.
+ */
+ 
+STATIC INLINE void _CORE_message_queue_Append (
+  CORE_message_queue_Control        *the_message_queue,
+  CORE_message_queue_Buffer_control *the_message
+);
+ 
+/*
+ *  _CORE_message_queue_Prepend
+ *
+ *  DESCRIPTION:
+ *
+ *  This routine places the_message at the rear of the outstanding
+ *  messages on the_message_queue.
+ */
+ 
+STATIC INLINE void _CORE_message_queue_Prepend (
+  CORE_message_queue_Control        *the_message_queue,
+  CORE_message_queue_Buffer_control *the_message
+);
+
+/*
+ *  _CORE_message_queue_Is_null
+ *
+ *  DESCRIPTION:
+ *
+ *  This function places the_message at the rear of the outstanding
+ *  messages on the_message_queue.
+ */
+ 
+STATIC INLINE boolean _CORE_message_queue_Is_null (
+  CORE_message_queue_Control *the_message_queue
+);
+
+#include <rtems/core/coremsg.inl>
+
+#ifdef __cplusplus
+}
+#endif
+ 
+#endif
+/*  end of include file */
+
